<script setup lang="ts">
import { ref } from 'vue'
import type { VForm } from 'vuetify/components'
import Addinvoice from './AddInvoiceDetail.vue'
import { useInvoiceStore } from '../../stores/invoice'
import { useInvoiceDetailStore } from '@/stores/invoiceDetail'
import { useUserStore } from '@/stores/user'
import { useMaterialStore } from '@/stores/material'
import type { Material } from '@/types/Material'
import type { InvoiceDetail } from '@/types/Invoice/InvoiceDetail'
import { useBranchStore } from '@/stores/branch'
import { useAuthStore } from '@/stores/auth'
import type { Invoice } from '@/types/Invoice/Invoice'

const authStore = useAuthStore()
const userStore = useUserStore()
const invoiceDetailStore = useInvoiceDetailStore()
const materialStore = useMaterialStore()
const branchStore = useBranchStore()
const invoiceStore = useInvoiceStore()
const form = ref(true)
const refForm = ref<VForm | null>(null)

async function save() {
  for (const material of materialStore.addsomeMaterial) {
    const existingMaterial = materialStore.materials.find(
      (mat) => mat.name.trim().toLowerCase() === material.name.trim().toLowerCase()
    )
    if (existingMaterial) {
      // Update existing material in materials array
      Object.assign(existingMaterial, material)
    } else {
      // Add new material from addsomeMaterial to materials array
      materialStore.materials.push(material)
    }
  }
  console.log('materials: ', materialStore.materials)
  for (const mat of materialStore.materials) {
    console.log('mat: ', mat)
    materialStore.saveMaterial(mat)
  }
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()

  const invoice = ref<Invoice>(invoiceStore.editedInvoice)
  //tran material to invoicedetail
  const newMaterials: Material[] = materialStore.materials
  const newInvoiceDetails: InvoiceDetail[] = invoiceDetailStore.addAllinvoiceDetails
  const invoiceDetails: InvoiceDetail[] = []
  for (const mat of newInvoiceDetails) {
    const newInvoiceDetail: InvoiceDetail = {
      IND_ID: -1,
      IND_AMOUT: mat.IND_AMOUT,
      IND_MATERIAL: mat.IND_MATERIAL,
      IND_PRICE: mat.IND_PRICE,
      IND_INVOICE: -1
    }

    invoiceDetails.push(newInvoiceDetail)
  }

  try {
    invoice.value = {
      INV_ID: -1,
      INV_PLACE: invoiceStore.place,
      INV_INVOICEDETAILS: invoiceDetails,
      INV_BRANCH: authStore.getCurrentUser()?.branch.id,
      INV_USER: authStore.getCurrentUser()?.id,
      INV_PRICE: invoiceStore.InvoicePrice(invoiceDetails)
    }
  } catch (error) {
    console.error('cant craeet invoice at add invoice some')
  }

  invoiceStore.saveInvoice(invoice.value)
  invoiceDetailStore.updateMatAllDetail()
  invoiceDetailStore.clearAddAllMat()
  console.log('invoice while saving: ', invoice.value)
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()
  invoiceStore.closeDialog()
}
</script>

<template>
  <v-dialog v-model="invoiceStore.addAllDialog" persistent width="1100" height="600">
    <v-card>
      <v-card-title>
        <h3 style="text-align: center;" class="mt-4">ADD invoice</h3>
        <!-- <span class="text-h5" style="text-align: center;">ADD invoice</span> -->
      </v-card-title>

      <v-card-text>
        <v-form ref="refForm" v-model="form">
          <v-container>
            <Addinvoice v-if="invoiceStore.addAllDialog"></Addinvoice>
          </v-container>
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>
        <v-spacer></v-spacer>
        <v-spacer></v-spacer>
        <v-row>
          <v-col cols="12" md="6">
            <v-text-field style="" v-model="invoiceStore.place" :rules="[(v) => !!v || 'Field is required']" clearable
              label="สถานที่ซื้อ" variant="outlined" filled rounded density="compact">
            </v-text-field>
          </v-col>

          <v-col cols="12" md="6">
            <v-btn variant="text" @click="invoiceStore.closeDialog()">
              Close
            </v-btn>
            <v-btn variant="text" @click="save()"> Save </v-btn>
          </v-col>
        </v-row>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-sheet,
.v-card {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 30px;
  padding: 8px 16px;
}

.info {
  font-size: 14px;
}
</style>
